/* Error Management
 */

#ifndef errorm_h
#define errorm_h

#include <string>
#include <iostream>
#include <stdarg.h>


std::string vstringf(const char* fmt, va_list va);
std::string stringf(const char* fmt, ...);


enum EventClass
{  Debug,
   Success,
   Information,
   Warning,
   Error,
   Fatal
};

const char* Class2String(EventClass cls);

class Event
{public:
   EventClass     Class;
   int            ID;
   std::string    Message;
   // generate
 protected:
   Event() {};
 public:
   Event(EventClass cls, int id, const char* msg, ...);
   // export
   operator std::string() const;
};

struct AEventHandler : public Event
{  virtual ~AEventHandler() {}
   virtual void PostEvent(const Event& e);
   AEventHandler& operator << (const Event& e) { PostEvent(e); return *this; }
};

struct EventLog : public AEventHandler
{  std::ostream* Log;
   EventLog(std::ostream& os) : Log(&os) {}
   virtual void PostEvent(const Event& e);
};


extern AEventHandler* DefEH;


#endif

